<template>
  <div>
    <div v-if="status === Status.LOADING">
      <content-loader-table
        :height="200"
        :num-rows="5"
      />
    </div>
    <div v-if="status === Status.ERROR">
      <b-list-group>
        <b-list-group-item variant="danger">
          <strong>Error Retrieving Cross-Matches</strong>
          <p class="mt-2 mb-0">
            {{ errorMessage }}
          </p>
        </b-list-group-item>
      </b-list-group>
    </div>
    <div v-if="status === Status.EMPTY">
      <b-list-group>
        <b-list-group-item variant="warning">
          <strong>No Cross-Matches</strong>
          <p class="mt-2 mb-0">
            ANTARES uses a 1" radius for cross-matching to point sources and variable radii
            for extended sources. We didn't find anything in our catalog databases for this
            object.
          </p>
        </b-list-group-item>
      </b-list-group>
    </div>
    <div v-else-if="status === Status.SUCCESS">
      <b-table
        :current-page="currentPage"
        :fields="fields"
        :items="catalogMatches"
        :sort-by.sync="sortBy"
        :sort-desc.sync="sortDesc"
        :per-page="perPage"
        bordered
        hover
        small
        style="white-space: nowrap"
        responsive
        striped
      >
        <template #cell(location)="data">
          <coordinates-formatter-icrs
            :dec="data.item.dec"
            :fraction-digits="2"
            :ra="data.item.ra"
            :display-copy-button="false"
            display-prefix=""
          />
        </template>
        <template #cell(details)="row">
          <div class="text-center">
            <base-button-icon
              :icon="row.detailsShowing ? 'eye-slash' : 'eye'"
              color="gray"
              size="md"
              @click="row.toggleDetails"
            />
          </div>
        </template>
        <template #row-details="row">
          <locus-catalog-match-details :catalog-match="row.item" />
        </template>
      </b-table>
      <div class="align-items-start d-flex justify-content-between">
        <div>
          <b-form inline>
            <label class="mr-2">Show</label>
            <b-form-select
              v-model="perPage"
              :options="pageOptions"
              class="mr-2"
            />
            <label class="mr-1">entries</label>
          </b-form>
          <p class="font-weight-lighter">
            Showing {{ pageStart }} to {{ pageEnd }} of {{ rows }} entries
          </p>
        </div>
        <b-pagination
          v-model="currentPage"
          :per-page="perPage"
          :total-rows="rows"
          align="right"
        />
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue';

import BaseButtonIcon from '@/components/BaseButtonIcon.vue';
import ContentLoaderTable from '@/components/ContentLoaderTable.vue';
import CoordinatesFormatterIcrs from '@/components/CoordinatesFormatterIcrs.vue';
import LocusCatalogMatchDetails from '@/components/LocusCatalogMatchDetails.vue';
import { LocusService } from '@/api';

/* eslint-disable-next-line no-shadow */
enum Status {
  EMPTY = 'EMPTY',
  LOADING = 'LOADING',
  ERROR = 'ERROR',
  SUCCESS = 'SUCCESS',
}

export default Vue.extend({
  components: {
    BaseButtonIcon,
    ContentLoaderTable,
    CoordinatesFormatterIcrs,
    LocusCatalogMatchDetails,
  },

  props: {
    locusId: {
      type: String,
      required: true,
    },
  },

  data() {
    return {
      Status,
      catalogMatches: [],
      currentPage: 1,
      errorMessage: '',
      fields: [
        {
          key: 'meta.catalog_name',
          label: 'Catalog',
          sortable: true,
        },
        {
          key: 'object_name',
          label: 'Object',
          sortable: true,
        },
        {
          key: 'meta.radius',
          label: 'Radius',
          sortable: true,
          formatter: (value: number) => `${value ? `${value.toFixed(2)}"` : 'N/A'}`,
        },
        {
          key: 'meta.separation',
          label: 'Sep.',
          sortable: true,
          formatter: (value: number) => `${value.toFixed(2)}"`,
        },
        {
          key: 'location',
          label: 'Location',
        },
        {
          key: 'details',
          label: 'Details',
        },
      ],
      pageOptions: [5, 10, 25, 50, 100],
      perPage: 10,
      sortBy: 'meta.separation',
      sortDesc: false,
      status: Status.LOADING,
    };
  },

  computed: {
    rows(): number {
      return this.catalogMatches.length;
    },
    pageStart(): number {
      return (this.currentPage - 1) * this.perPage + 1;
    },
    pageEnd(): number {
      const pageEnd = this.pageStart + this.perPage - 1;
      return pageEnd > this.rows ? this.rows : pageEnd;
    },
  },

  mounted() {
    this.fetchCatalogMatches();
  },

  methods: {
    async fetchCatalogMatches() {
      this.status = Status.LOADING;
      try {
        const { data: catalogMatches, meta } = await LocusService.listCatalogMatches(
          this.locusId,
          {},
        );
        this.catalogMatches = catalogMatches;
        if (meta.count === 0) {
          this.status = Status.EMPTY;
        } else {
          this.status = Status.SUCCESS;
        }
      } catch (error) {
        /* eslint-disable-next-line prefer-destructuring */
        this.errorMessage = error[0];
        this.status = Status.ERROR;
      }
    },
  },
});
</script>
